From 6d027aa9d022eee90adc2095409f0ad37efcdeb9 Mon Sep 17 00:00:00 2001
From: Christian Feldmann <christian.feldmann@gmx.de>
Date: Wed, 14 Sep 2022 18:05:50 +0200
Subject: [PATCH] Copy all values also for 10 bit input

---
 libavfilter/vf_libvmaf.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/libavfilter/vf_libvmaf.c b/libavfilter/vf_libvmaf.c
index eee1c280ef..8d5ba4e2d5 100644
--- a/libavfilter/vf_libvmaf.c
+++ b/libavfilter/vf_libvmaf.c
@@ -108,6 +108,7 @@ static enum VmafPixelFormat pix_fmt_map(enum AVPixelFormat av_pix_fmt)
 
 static int copy_picture_data(AVFrame *src, VmafPicture *dst, unsigned bpc)
 {
+    const int bytes_per_value = bpc > 8 ? 2 : 1;
     int err = vmaf_picture_alloc(dst, pix_fmt_map(src->format), bpc,
                                  src->width, src->height);
     if (err)
@@ -117,7 +118,7 @@ static int copy_picture_data(AVFrame *src, VmafPicture *dst, unsigned bpc)
         uint8_t *src_data = src->data[i];
         uint8_t *dst_data = dst->data[i];
         for (unsigned j = 0; j < dst->h[i]; j++) {
-            memcpy(dst_data, src_data, sizeof(*dst_data) * dst->w[i]);
+            memcpy(dst_data, src_data, bytes_per_value * dst->w[i]);
             src_data += src->linesize[i];
             dst_data += dst->stride[i];
         }
-- 
2.25.1

